//
// This is the interface that the EventMailbox's proxy implements.
//

package corejini.chapter16;

import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.EventRegistration;
import net.jini.core.lease.UnknownLeaseException;
import java.util.List;
import java.rmi.Remote;
import java.rmi.RemoteException;

public interface EventMailboxRequest extends RemoteEventListener, Remote {
    // Get a mailbox
    public EventRegistration acquireMailbox(Object source,
                                            long eventType,
                                            long duration)
        throws RemoteException;
    
    // Get events in a batch
    public List getEvents(Object source, long eventType) 
        throws RemoteException, UnknownLeaseException;
    
    // Have events re-delivered to the original listener.
    public void deliverEvents(Object source, long eventType,
                              RemoteEventListener listener)
        throws RemoteException, UnknownLeaseException;
} 
